<template>
  <div class="table-container">
    <vab-query-form>
      <div class="title">
        <div class="left">
          <div class="left-item">
            <div>场站：</div>
            <el-select v-model="selectValue" placeholder="请选择" clearable>
              <el-option v-for="item in stationList" :key="item.id" :label="item.name" :value="item.id">
              </el-option>
            </el-select>
          </div>
          <div class="left-item">
            <div style="width: 70px;">名称：</div>
            <el-input v-model="fuzzyQuery" placeholder="请输入" clearable />
          </div>
          <el-button icon="el-icon-search" type="primary" native-type="submit" @click="fetchData">
            查询
          </el-button>
        </div>
        <div class="right">
          <el-button icon="el-icon-plus" type="primary" @click="handleAdd">
            添加
          </el-button>
          <el-button icon="el-icon-delete" type="danger" @click="handleDelete">
            删除
          </el-button>
        </div>
      </div>
      <el-table ref="tableSort" v-loading="listLoading" :data="list" :element-loading-text="elementLoadingText"
        :height="height" @selection-change="setSelectRows">
        <el-table-column show-overflow-tooltip type="selection" width="40"></el-table-column>
        <el-table-column show-overflow-tooltip label="id" prop="id" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="编码" prop="code" align="center" sortable></el-table-column>
        <el-table-column width="120" show-overflow-tooltip label="工程名称" prop="name" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="别称" prop="aname" align="center" sortable></el-table-column>
        <el-table-column width="120" show-overflow-tooltip label="装机容量" prop="capacity" align="center" sortable></el-table-column>
        <el-table-column width="120" show-overflow-tooltip label="容量单位" prop="capacityunit" align="center" sortable>
        </el-table-column>
        <el-table-column width="120" show-overflow-tooltip label="投产日期" prop="commissiondate" align="center" sortable>
        </el-table-column>
        <el-table-column width="120" show-overflow-tooltip label="主控电话" prop="masterphone" align="center" sortable>
        </el-table-column>
        <el-table-column show-overflow-tooltip label="机型" prop="model" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="顺序" prop="ordernum" align="center" sortable></el-table-column>
        <el-table-column width="120" show-overflow-tooltip label="装机数量" prop="quantity" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="值长" prop="shiftforeman" align="center" sortable></el-table-column>
        <el-table-column width="120" show-overflow-tooltip label="值长电话" prop="shiftforemanphone" align="center" sortable>
        </el-table-column>
        <el-table-column width="120" show-overflow-tooltip label="风场编号" prop="windpowerstationid" align="center" sortable>
        </el-table-column>
        <el-table-column show-overflow-tooltip label="操作" width="100px" fixed="right">
          <template #default="{ row }">
            <el-button type="text" @click="handleEdit(row)">编辑</el-button>
            <el-button type="text" @click="handleDelete(row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <el-pagination :background="background" :current-page="queryForm.pageNo" :layout="layout"
        :page-size="queryForm.pageSize" :total="total" @current-change="handleCurrentChange"
        @size-change="handleSizeChange"></el-pagination>
      <table-edit ref="edit" :options="options" :stationList="stationList" @save-success="fetchData"></table-edit>
    </vab-query-form>
  </div>
</template>
<script>
import api from '@/api/station'
import TableEdit from './components/TableEdit'
export default {
  components: {
    TableEdit,
  },
  data() {
    return {
      fuzzyQuery: '',
      listLoading: true,
      list: [],
      options: [],
      exportExcel: [],
      elementLoadingText: '正在加载...',
      selectRows: '',
      layout: 'total, sizes, prev, pager, next, jumper',
      total: 0,
      background: true,
      exportList: [],
      queryForm: {
        pageNo: 1,
        pageSize: 20,
      },
      stationList: [],
      selectValue: ''
    };
  },
  computed: {
    height() {
      return this.$baseTableHeight() + 50
    },
  },
  created() {
    this.getStation()
    this.fetchData()
  },
  methods: {
    getStation() {
      api.windpowerstationList({
        id: '',
        name: '',
        companyid: '',
        pageNum: 1,
        pageSize: 1000,
      }).then(res => {
        if (res.data) {
          this.listLoading = false
          this.stationList = res.data.records
        }
      })
    },
    fetchData() {
      api.projectList({
        windpowerstationid: this.selectValue,
        name: this.fuzzyQuery,
        pageNum: this.queryForm.pageNo,
        pageSize: this.queryForm.pageSize,
      }).then(res => {
        if (res.data) {
          this.listLoading = false
          this.total = res.data.total
          this.list = res.data.records
        }
      })
    },
    handleSizeChange(val) {
      this.queryForm.pageSize = val
      this.fetchData()
    },
    handleCurrentChange(val) {
      this.queryForm.pageNo = val
      this.fetchData()
    },
    handleAdd() {
      this.$refs['edit'].showEdit()
    },
    handleEdit(row) {
      this.$refs['edit'].showEdit(row)
    },
    handleDelete(row) {
      if (row.id || this.selectRows.length > 0) {
        this.$baseConfirm('你确定要删除吗', null, async () => {
          let ids = ''
          if (this.selectRows.length > 0) {
            ids = this.selectRows.map((item) => item.id).join()
          }
          api.deleteProject({
            id: row.id || ids
          }).then(res => {
            if (res.data) {
              this.$baseMessage('删除成功', 'success')
              this.fetchData()
            }
          })
        })
      } else {
        this.$baseMessage('未选中任何行', 'error')
        return false
      }
    },
    setSelectRows(val) {
      this.selectRows = val
    },
  },
}
</script>
<style lang="less" scoped>
.title {
  display: flex;
  flex-direction: row;
  align-items: center;
  justify-content: space-between;
  margin-bottom: 20px;
}

.left {
  display: flex;
  flex-direction: row;
  align-items: center;

  .left-item {
    display: flex;
    flex-direction: row;
    align-items: center;
    margin-right: 10px;
  }
}
</style>